﻿Imports System
Imports System.Threading
Imports System.IO.Ports

Public Class Form1

    Const SERIAL_TIMEOUT As Integer = 500
    Const BUFFER_SIZE As Integer = 256

    Private Total As Integer
    Private Cache As Integer
    Private serialPortBVCM As System.IO.Ports.SerialPort = New System.IO.Ports.SerialPort
    Private ListBox1 As New ListBox
    Private PortBVCM As String
    Private CommandBuffer As String
    Private ResponseBuffer As String
    Private DisplayFlag As Boolean = False
    Private LineResetFlag As Boolean = False

    Private ResponsStatus As Boolean
    Private ResponsBvcmStatus As Byte
    Private ResponsCancelStatus As Boolean
    Private ResponsChangeStatus As Byte
    Private ResponsErrorStatus As Byte
    Private ResponsSettledResult As Integer
    Private ResponsTotalAmount As Integer
    Private ResponsCardId As String
    Private ResponsAfterAmount As Integer

    Private Const ITEM1_PRICE = 1
    Private Const ITEM2_PRICE = 20
    Private Const ITEM3_PRICE = 300


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        ListBox1.SelectionMode = SelectionMode.One
        GetSerialPortNames()
        ScanSerialPort()
        If PortBVCM = "" Then
            MessageBox.Show("BVCM-MIF-Easy_IM10: 接続されていません")
            Close()
        Else
            Label1.Text = "\" & ITEM1_PRICE
            Label2.Text = "\" & ITEM2_PRICE
            Label3.Text = "\" & ITEM3_PRICE
            Label6.ForeColor = Color.MediumOrchid
            LineResetFlag = True                            'Reset Once after boot up
            Label6.Text = "起動中"
            Timer1.Enabled = True
            Button6.Enabled = True
        End If
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Total = ITEM1_PRICE
        TextBox1.Text = Total
        CommandShell("SetAmount," & Total.ToString & ",1")
        Timer1.Enabled = True
        'Button1.Enabled = False
        'Button2.Enabled = False
        'Button3.Enabled = False
        Button4.Enabled = True
        DisplayFlag = True
        Me.ActiveControl = Nothing
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Total = ITEM2_PRICE
        TextBox1.Text = Total
        CommandShell("SetAmount," & Total.ToString & ",2")
        Timer1.Enabled = True
        'Button1.Enabled = False
        'Button2.Enabled = False
        'Button3.Enabled = False
        Button4.Enabled = True
        DisplayFlag = True
        Me.ActiveControl = Nothing
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Total = ITEM3_PRICE
        TextBox1.Text = Total
        CommandShell("SetAmount," & Total.ToString & ",3")
        Timer1.Enabled = True
        'Button1.Enabled = False
        'Button2.Enabled = False
        'Button3.Enabled = False
        Button4.Enabled = True
        DisplayFlag = True
        Me.ActiveControl = Nothing
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        If (Total > 0) Then
            CommandShell("Cancel")
        End If
        Me.ActiveControl = Nothing
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        Dim timestr As String

        timestr = DateString(DateTime.Now)
        CommandShell("StartClosing," & timestr)
        Timer1.Interval = 500
        Timer1.Enabled = True
        Me.ActiveControl = Nothing
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim stat As Boolean
        Dim dt As String
        Dim timestr As String
        Dim i As Integer
        Dim txt As String

        If DisplayFlag = True Then
            DisplayFlag = False
            Label6.ForeColor = Color.Green
            Label6.Text = "電子マネーで決済してください"
            Timer1.Interval = 300
        End If

        CommandShell("GetStatus")
        stat = ParseResponse()

        System.Diagnostics.Debug.WriteLine(ResponsBvcmStatus)
        System.Diagnostics.Debug.WriteLine(ResponsErrorStatus)
        System.Diagnostics.Debug.WriteLine("")

        If ResponsBvcmStatus = 0 Then                                       ' リセット中
            Button1.Enabled = False
            Button2.Enabled = False
            Button3.Enabled = False
            Button4.Enabled = True
            Label6.ForeColor = Color.MediumOrchid
            Label6.Text = "起動中"
            Timer1.Interval = 300
            Timer1.Enabled = True

        ElseIf ResponsBvcmStatus = 1 Then                                   ' アイドル

            If LineResetFlag Then                                           ' Reset Once after becoming Idle
                timestr = DateString(DateTime.Now)
                '                CommandShell("LineReset,0,0,100," & timestr & ",20,1")
                CommandShell("LineReset,0,0,100," & timestr & ",20,1")
                dt = Mid(ResponseBuffer, 1, 2)
                If dt = "OK" Then
                    LineResetFlag = False
                End If
                Return
            End If

            TextBox1.Text = 0
            Button1.Enabled = True
            Button2.Enabled = True
            Button3.Enabled = True
            Button4.Enabled = False
            Button5.Enabled = True
            Label6.ForeColor = Color.DarkGray
            Label6.Text = "商品を選択して下さい"
            'Timer1.Enabled = False
            DisplayFlag = False

        ElseIf ResponsBvcmStatus = 3 Or ResponsBvcmStatus = 4 Then          ' 決済完了 又は キャンセル

            If ResponsSettledResult = 1 Then                                ' 決済ＯＫ
                CommandShell("GetSettledData")
                CommandShell("GetReceiptData")
                TextBox2.Text = ResponseBuffer
                Label6.ForeColor = Color.Green
                Label6.Text = "決済完了　　"
                Label6.Text = Label6.Text & ResponsTotalAmount
                Label6.Text = Label6.Text & "円"
                Timer1.Interval = 5000
                DisplayFlag = True

            ElseIf ResponsSettledResult = 2 Then                            ' 決済キャンセル
                CommandShell("GetSettledData")
                CommandShell("GetReceiptData")
                TextBox2.Text = ResponseBuffer
                Label6.ForeColor = Color.DarkGoldenrod
                Label6.Text = "決済キャンセル"
                TextBox1.Text = 0
                Timer1.Interval = 2000
                DisplayFlag = True

            ElseIf ResponsSettledResult = 3 Then                            ' 決済ＮＧ
                CommandShell("GetSettledData")
                CommandShell("GetReceiptData")
                TextBox2.Text = ResponseBuffer
                Label6.ForeColor = Color.Red
                Label6.Text = "決済出来ません"
                Timer1.Interval = 5000
                DisplayFlag = True
            End If

            Button4.Enabled = False

        ElseIf ResponsBvcmStatus = 5 Then                                   ' 処理未了継続中
            Label6.ForeColor = Color.Magenta
            Label6.Text = "もう一度タッチして下さい"
            ' Button4.Enabled = False
            Timer1.Interval = 300
            DisplayFlag = False

        ElseIf ResponsBvcmStatus = 6 Then                                   ' 締め処理中
            Label6.ForeColor = Color.DarkGoldenrod
            Label6.Text = "締め処理中"
            Button1.Enabled = False
            Button2.Enabled = False
            Button3.Enabled = False
            Button4.Enabled = False
            CommandShell("ReadData")
            dt = TakeElement(ResponseBuffer)
            txt = vbNull
            If dt = "OK" Then
                For i = 0 To 5
                    dt = TakeElement(ResponseBuffer)
                    txt &= dt & vbNewLine
                Next
                TextBox2.Text = txt
                System.Threading.Thread.Sleep(500)
            End If

        ElseIf ResponsBvcmStatus = 7 Then                                   ' 締めSW検出
            timestr = DateString(DateTime.Now)
            CommandShell("StartClosing," & timestr)
            Timer1.Interval = 500
            Timer1.Enabled = True

        End If

    End Sub

    Private Sub GetSerialPortNames()
        ' Show all available COM ports.
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ListBox1.Items.Add(sp)
        Next
    End Sub

    Private Sub ScanSerialPort()
        Dim i As Integer
        Dim portname As String
        Dim stat As Boolean

        PortBVCM = ""
        For i = 1 To ListBox1.Items.Count
            ListBox1.ClearSelected()
            ListBox1.SetSelected(i - 1, True)
            portname = ListBox1.SelectedItem
            stat = CheckBvcmPort(portname)
            If stat = True Then
                If ResponseBuffer.Substring(0, 16) = "BVCM-MIF-02_IM10" Then
                    TextBox2.Text = ResponseBuffer
                    PortBVCM = portname
                    Exit For
                End If
            End If
            If serialPortBVCM.IsOpen Then
                serialPortBVCM.Close()
            End If
        Next
    End Sub

    Public Function Serial_Open(ByVal comportNo As String) As Boolean
        Try
            If serialPortBVCM.IsOpen Then
                serialPortBVCM.Close()
            End If

            serialPortBVCM.BaudRate = 38400
            serialPortBVCM.DataBits = 8
            serialPortBVCM.StopBits = System.IO.Ports.StopBits.One
            serialPortBVCM.Parity = System.IO.Ports.Parity.None
            serialPortBVCM.PortName = comportNo
            serialPortBVCM.NewLine = vbCr
            serialPortBVCM.RtsEnable = True
            serialPortBVCM.DtrEnable = False
            serialPortBVCM.ReceivedBytesThreshold = 1
            serialPortBVCM.ReadTimeout = SERIAL_TIMEOUT                            ' [msec]
            serialPortBVCM.WriteTimeout = SERIAL_TIMEOUT                           ' [msec]
            serialPortBVCM.Open()

        Catch ee As Exception
            Return False
        End Try

        Return True

    End Function

    Private Function CheckBvcmPort(ByVal portname As String) As Boolean
        Dim stat As Boolean

        stat = Serial_Open(portname)
        If stat = True Then
            CommandBuffer = "GetVersion"
            stat = ExecCommand(CommandBuffer, ResponseBuffer)
        End If

        Return stat
    End Function

    Private Sub CommandShell(ByVal cmnd As String)
        Dim stat As Boolean
        Dim i As Integer

        CommandBuffer = cmnd
        For i = 1 To 3                                  ' エラー時は３回リトライ
            stat = ExecCommand(CommandBuffer, ResponseBuffer)
            If stat = True Then
                Exit For
            End If
        Next

        If stat = False Then
            MessageBox.Show("BVCM-MIF-02_Easy: 通信異常")
            Close()
        End If

    End Sub

    Private Function ExecCommand(ByRef cmnd As String, ByRef rsps As String) As Boolean

        Dim sum As Byte
        Dim stat As Boolean

        cmnd = cmnd & ","                               ' コマンドにカンマを追加
        sum = CalcSum(cmnd)                             ' チェックサム算出
        cmnd = cmnd & sum.ToString("X2")                ' チェックサムを文字として追加
        serialPortBVCM.DiscardInBuffer()                ' 受信バッファクリア
        serialPortBVCM.DiscardOutBuffer()               ' 送信バッファクリア

        serialPortBVCM.WriteLine(cmnd)                  ' コマンド送信
        stat = GetResponse(rsps)                        ' レスポンス受信

        Return stat
    End Function

    Private Function CalcSum(ByRef txt As String) As Byte

        Dim i As Integer
        Dim ch As Char
        Dim sum As Integer = 0

        For i = 1 To txt.Length                        ' チェックサム算出
            ch = Mid(txt, i, 1)
            sum = sum + Asc(ch)
        Next

        Return sum Mod 256

    End Function

    Private Function GetChar(ByRef chr As Byte) As Boolean

        Dim ret As Boolean
        Dim sw As New System.Diagnostics.Stopwatch()

        ret = False
        Try
            sw.Start()
            While sw.ElapsedMilliseconds < SERIAL_TIMEOUT
                If serialPortBVCM.BytesToRead > 0 Then
                    chr = serialPortBVCM.ReadByte
                    ret = True
                    Exit While
                End If
            End While
            sw.Stop()

            Return ret

        Catch ee As Exception
            Return ret
        End Try

    End Function

    Private Function GetResponse(ByRef rsps As String) As Boolean

        Dim dt As Byte
        Dim stat As Boolean
        Dim sum, rdsum As Byte
        Dim sumstr As String

        Try
            rsps = ""                                               ' レスポンスバッファー初期化
            Do
                stat = GetChar(dt)
                If Not stat Then                                    ' タイムアウト
                    Exit Do
                End If

                rsps = rsps & Chr(dt)

                If dt = &HD Then                                    ' CRまで受信
                    Exit Do
                Else                                                ' バッファオーバーフロー
                    If rsps.Length >= BUFFER_SIZE Then
                        stat = False
                        Exit Do
                    End If
                End If
            Loop

            If stat = True Then                                     ' CRまで正常受信できていれば
                rsps = Strings.Left(rsps, rsps.Length - 1)          ' CRを取り除く
                sumstr = Mid(rsps, rsps.Length - 1, 2)              ' 最後の２文字をチェックサムとして取り出す
                rdsum = Convert.ToByte(sumstr, 16)                  ' １６進数値変換
                rsps = Strings.Left(rsps, rsps.Length - 2)          ' チェックサム文字を削除
                sum = CalcSum(rsps)                                 ' チェックサム算出
                If sum <> rdsum Then                                ' チェックサムＮＧ
                    rsps = ""
                    stat = False
                End If
            Else
                rsps = ""
            End If


        Catch ex As Exception
            stat = False
        End Try

        Return stat
    End Function

    Private Function ParseResponse() As Boolean
        Dim i, j, k As Integer
        Dim dt As String
        Dim exitflag As Boolean
        Dim ret As Boolean = False

        j = 1
        For i = 1 To 7
            exitflag = False
            k = j
            While True
                If Mid(ResponseBuffer, k, 1) = "," Then
                    Exit While
                End If
                k = k + 1
            End While

            If k = j Then
                dt = ""
            Else
                dt = Mid(ResponseBuffer, j, k - j)
            End If
            j = k + 1

            Select Case i
                Case 1
                    If dt = "OK" Then
                        ResponsStatus = True
                        ret = True
                    Else
                        ResponsStatus = False
                        ResponsBvcmStatus = 0
                        ResponsCancelStatus = False
                        ResponsChangeStatus = 0
                        ResponsErrorStatus = 0
                        ResponsTotalAmount = 0
                        exitflag = True
                    End If

                Case 2
                    ResponsBvcmStatus = Convert.ToByte(dt, 16)

                Case 3
                    ResponsCardId = dt

                Case 4
                    ResponsAfterAmount = Convert.ToInt64(dt)

                Case 5
                    ResponsErrorStatus = Convert.ToByte(dt, 16)

                Case 6
                    ResponsSettledResult = Convert.ToInt64(dt)

                Case 7
                    ResponsTotalAmount = Convert.ToInt64(dt)

            End Select

            If exitflag = True Then
                Exit For
            End If
        Next

        Return ret
    End Function

    Private Function DateString(dt As DateTime) As String
        Dim str, str1, str2 As String
        Dim day As String

        str = vbNull
        str1 = dt.ToString("yyyyMMdd")
        str2 = dt.ToString("HHmmss")
        day = dt.ToString("ddd")
        Select Case day
            Case "日"
                str = str1 & "0" & str2
            Case "月"
                str = str1 & "1" & str2
            Case "火"
                str = str1 & "2" & str2
            Case "水"
                str = str1 & "3" & str2
            Case "木"
                str = str1 & "4" & str2
            Case "金"
                str = str1 & "5" & str2
            Case "土"
                str = str1 & "6" & str2
        End Select

        Return str
    End Function

    Private Function TakeElement(ByRef dt As String) As String
        Dim ret As String

        ret = Strings.Left(dt, dt.IndexOf(","))
        dt = dt.Substring(dt.IndexOf(",") + 1)

        Return ret
    End Function

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click

        LineResetFlag = True                            'Reset Once after boot up
        Label6.Text = "起動中"
        Timer1.Enabled = True
        Button6.Enabled = True

    End Sub
End Class
